
"""
.
"""


from __future__ import absolute_import, division, print_function

import numpy as np
from causaltest.bin.conf import NB_BUCKETS


def random_split(array_to_split: np.array):
    # When len(array_to_split) is odd, we round half of the time upp, half down.
    size = round(len(array_to_split)/2 - 0.1 + np.random.rand()/5)

    treatment = np.random.choice(a=array_to_split, size=size, replace=False)
    control = np.setdiff1d(array_to_split, treatment)
    return [list(treatment), list(control)]


def perform_stratified_random_split(fact_geo, dim_geo): # TODO: est-ce qu'il ne faudrait pas init fact et dim ?
    """

    """
    df_fact_geo_include = fact_geo.loc[fact_geo.id.isin(dim_geo.loc[
        (dim_geo.to_exclude == False) | (dim_geo.to_exclude.isna())].id
    )]
    include_geo_id = np.array(df_fact_geo_include[['id', 'nb']].groupby('id')\
                                                               .sum()\
                                                               .sort_values("nb", ascending=False)\
                                                               .index.values)
    nb_include_geo_id = len(include_geo_id)
    buckets = []
    treatment_geo_id = []
    control_geo_id = []
    l = int(np.ceil(nb_include_geo_id / NB_BUCKETS))

    for k in range(NB_BUCKETS+1):
        sub = include_geo_id[k*l:(k+1)*l]
        buckets.extend(sub)
        treatment, control = random_split(np.array(sub))
        treatment_geo_id.extend(treatment)
        control_geo_id.extend(control)
    exclude_geo_id = dim_geo.loc[dim_geo.to_exclude == True].id.tolist()

    return treatment_geo_id, control_geo_id, exclude_geo_id
