import codecs
import os
import re

import setuptools

CURRENT_FILEPATH = os.path.abspath(os.path.dirname(__file__))
VERSION_FILENAME = 'version.py'


def find_version():
    # Source: https://packaging.python.org/guides/single-sourcing-package-version/
    with codecs.open(os.path.join(CURRENT_FILEPATH, VERSION_FILENAME), 'r') as f:
        version_file = f.read()
    version_match = re.search(r"^__version__ = ['\"]([^'\"]*)['\"]", version_file, re.M)
    if version_match:
        return version_match.group(1)
    raise RuntimeError("Unable to find version string.")


setuptools.setup(
    name="causaltest",
    version=find_version(),
    author="Hugo Palmer & Antoine Barczewski",
    author_email="antoine.barczewski@blablacar.com",
    description="A lib for incrementality test setting and measuring",
    license='closed',
    url="https://bitbucket.corp.blablacar.com/projects/lib/repos/causaltest",
    packages=setuptools.find_packages(),
    python_requires='>=3.6',
    install_requires=['humanfriendly', 'pyyaml', 'jinja2', 'GitPython']
)
